﻿using Infragistics.Win.FormattedLinkLabel;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp23
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraDataSource1.Band.Columns.Add("String 1");
            this.ultraDataSource1.Band.Columns.Add("String 2");
            this.ultraDataSource1.Band.Columns.Add("String 3");

            for (int i = 0; i <400; i++)
            {
                var ultraDataRow = this.ultraDataSource1.Rows.Add();
                ultraDataRow["String 1"] = GetRandomXmlForCell();
                ultraDataRow["String 2"] = GetRandomXmlForCell();                
                ultraDataRow["String 3"] = GetRandomXmlForCell();
            }

            this.ultraGrid1.InitializeLayout += UltraGrid1_InitializeLayout;
            this.ultraGrid1.SetDataBinding(this.ultraDataSource1, this.ultraDataSource1.Band.Key);
        }

        private void UltraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var band = layout.Bands[0];
            foreach (var column in band.Columns)
            {
                column.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.FormattedTextEditor;
            }
        }

        private string GetRandomXmlForCell()
        {
            var image = DummyDataCreator.GetTextBitmap(DummyDataCreator.RandomCharacter().ToString());
            var encodedImg = FormattedLinkEditor.EncodeImage(image);
            var xml = $"<img style=\"width: {image.Width}px; height: {image.Height}px; \" data=\"{encodedImg}\"/>";            
            return xml;
        }
    }
}
